hdu 1081

To The Max

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 7927    Accepted Submission(s): 3831

Problem Description

Given a two-dimensional array of positive and negative integers, a sub-rectangle is any contiguous sub-array of size 1 x 1 or greater located within the whole array. The sum of a rectangle is the sum of all the elements in that rectangle. In this problem the sub-rectangle with the largest sum is referred to as the maximal sub-rectangle.

As an example, the maximal sub-rectangle of the array:

0 -2 -7 0
9 2 -6 2
-4 1 -4 1
-1 8 0 -2

is in the lower left corner:

9 2
-4 1
-1 8

and has a sum of 15.

Input

The input consists of an N x N array of integers. The input begins with a single positive integer N on a line by itself, indicating the size of the square two-dimensional array. This is followed by N 2 integers separated by whitespace (spaces and newlines). These are the N 2 integers of the array, presented in row-major order. That is, all numbers in the first row, left to right, then all numbers in the second row, left to right, etc. N may be as large as 100. The numbers in the array will be in the range [-127,127].

Output

Output the sum of the maximal sub-rectangle.

Sample Input

4

0 -2 -7 0

9 2 -6 2

-4 1 -4 1

-1
8 0 -2

Sample Output

15

二维最大连续子段和,枚举列数(i->j)第i列到第j列,计算每一行第i列到第j列的和,然后用每一行的这个和用一维的求最大连续子序列的和的方法求就行了,

求和的时候可以预处理一下,ma[i][j]表示第i行前j列的和,这样求第i列到第j列的和就可以用ma[k][j] - ma[k][i-1]表示。

#include <stdio.h>
#include <string.h>
#define N 105
#define INF 0x3f3f3f3f
int ma[N][N];
int main()
{
    int n,i,j,k,maxx,sum;
    while(~scanf("%d",&n))
    {
        memset(ma,0,sizeof(ma));
        for(i = 1; i<= n ; i++)
        {
            for(j = 1 ; j<= n ;j++)
            {
                scanf("%d",&ma[i][j]);
                ma[i][j]+=ma[i][j-1];
            }
        }
        sum = 0 ;maxx = -INF;
        for(i = 1 ; i <= n ; i++)
        {
            for(j = i ; j <= n ; j++)
            {
                //printf("%d ",ma[i][j]);
                sum = 0;
                for(k = 1 ; k<= n ; k++)
                {
                    //if(sum==17) printf("i = %d j = %d k = %d\n",i,j,k);
                    sum+=ma[k][j] - ma[k][i-1];
                    if(sum>maxx) maxx = sum;
                    if(sum<0) sum = 0;
                }
            }
           // printf("\n");
        }
        printf("%d\n",maxx);
    }
    return 0;
}

hdu 1081

时间: 2024-10-29 19:44:58

hdu 1081的相关文章

HDU 1003 &amp;&amp; HDU 1081(最大子列和,最大子矩阵和).

最大子列和,及其扩展最大子矩阵和,都是比较经典的dp,把这两题写在一起,共大家参考学习. ~~~~ lz弱菜啊,到现在还只能写这么水的DP...orz. ~~~~ 题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1003 http://acm.hdu.edu.cn/showproblem.php?pid=1081 题意应该比较好理解,不解释了. 1003: #include<cstdio> #include<iostream> #inc

hdu 1081 &amp; poj 1050 To The Max(最大和的子矩阵)

转载请注明出处:http://blog.csdn.net/u012860063 Description Given a two-dimensional array of positive and negative integers, a sub-rectangle is any contiguous sub-array of size 1*1 or greater located within the whole array. The sum of a rectangle is the sum

hdu 1081最大子矩阵的和DP

To The Max Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 8210    Accepted Submission(s): 3991 Problem Description Given a two-dimensional array of positive and negative integers, a sub-rectan

HDU 1081 To The Max(DP)

题意  求一个n*n矩阵的最大子矩阵和 HDU 1003 max sum 的升级版   把二维简化为一维就可以用1003的方法去做了  用mat[i][j]存  第i行前j个数的和   那么mat[k][j]-mat[k][i]就表示第k行  第i+1个数到第j个数的和了   再将k从一枚举到n就可以得到这个这个宽度为j-i的最大矩阵和了   然后i,j又分别从1枚举到n就能得到结果了   和1003的方法一样  只是多了两层循环 #include<cstdio> #include<cs

HDU 1081 To The Max 暴力模拟O(n^4) dp优化O(n^3)

原题: http://acm.hdu.edu.cn/showproblem.php?pid=1081 题目大意: 求给定边长的正方形选一个矩形,使它包含的所有元素的值最大. 大家都知道(a+b)^2的展开式,这里的优化就是用了这个原理来做的优化,我们的dp值是我们前i行j列的矩形区域的值. 任意矩形区域的值通过该展开式也能求解,所以我们可以暴力枚举每种以左上角(k,l)到右下角(i,j)的情况. 对于这个题边长是100,4层循环是10^8,因为循环并跑不了这么多,刚好也能卡过去. 代码如下: #

hdu 1081 To The Max(dp+化二维为一维)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1081 To The Max Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 8839    Accepted Submission(s): 4281 Problem Description Given a two-dimensional ar

(DP)To The Max --HDU -- 1081

链接: http://acm.hdu.edu.cn/showproblem.php?pid=1081 代码: #include<stdio.h> #include<string.h> #include<stdlib.h> #define max2(a,b) (a>b?a:b) #define N 110 #define INF 0xfffffff int a[N][N], b[N][N][N]; int main() { int n; while(scanf(&q

HDU 1081 To The Max

题目链接 Problem Description Given a two-dimensional array of positive and negative integers, a sub-rectangle is any contiguous sub-array of size 1 x 1 or greater located within the whole array. The sum of a rectangle is the sum of all the elements in th

HDU 1081 To The Max--DP--(最大子矩阵)

题意:输入一个二维数组,求和最大的子矩阵 分析:一看到和最大的子XX,我就联想到和最大子序列,只不过那是一维这是二维,所以做法都差不多.把二维压缩成一维:你想啊一个矩阵的和不是可以先垂直方向相加把所有行压缩为一行然后这一行相加嘛.压缩过后找最大和的方法跟一维一模一样.但我自己做的时候写了四个循环,唉.....数组可以存放之前求过的和,那么求以下一行为结尾的和的时候只要在原来的数组上加这一行的数就行了,不需要从头循环求和! dp[k]=a[i][k]+.....+a[j][k] 第 k 列第 i